#!/usr/bin/perl
#
use strict;
use warnings;
use RRDTool::OO;

my $rc = 0;
my $DB_heizgeraet  = "/home/junky/workspace/projects/trunk/HT3/software/var/databases/HT3_db_rrd_heizgeraet.rrd";
my $heizgeraet_rrdh = RRDTool::OO->new(file => $DB_heizgeraet);
my $DB_heizkreis  = "/home/junky/workspace/projects/trunk/HT3/software/var/databases/HT3_db_rrd_heizkreis.rrd";
my $heizkreis_rrdh = RRDTool::OO->new(file => $DB_heizkreis);
my $DB_warmwasser  = "/home/junky/workspace/projects/trunk/HT3/software/var/databases/HT3_db_rrd_warmwasser.rrd";
my $warmwasser_rrdh = RRDTool::OO->new(file => $DB_warmwasser);
my $DB_solar  = "/home/junky/workspace/projects/trunk/HT3/software/var/databases/HT3_db_rrd_solar.rrd";
my $solar_rrdh = RRDTool::OO->new(file => $DB_solar);
my $DB_sysdatetime  = "/home/junky/workspace/projects/trunk/HT3/software/var/databases/HT3_db_rrd_sysdatetime.rrd";
my $sysdatetime_rrdh = RRDTool::OO->new(file => $DB_sysdatetime);
# 
# Set Starttime
my $start_time     = 1391975736;
# 
# Define the RRD
# RRA's consolidation function must be one of the following:
#  ['AVERAGE', 'MIN', 'MAX', 'LAST', 'HWPREDICT', 'SEASONAL',
#   'DEVSEASONAL', 'DEVPREDICT', 'FAILURES']
# 
# Define the archiv
# 'LAST    saved every 5 min, kept for 20years back
# 'AVERAGE saved every 1 min, kept for  1year  back
# 'MAX  saved every 5 min, kept for 1year back
# 'MIN  saved every 5 min, kept for 1year back
# 
$rc = $heizgeraet_rrdh->create(
    start       => $start_time - 600,
    step        => 60,
        data_source => { 
            name    => 'T_vorlauf_soll',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'T_vorlauf_ist',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'T_ruecklauf',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'T_mischer',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_modus',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_brenner_motor',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_brenner_flamme',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_leistung',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_heizungs_pumpe',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_zirkula_pumpe',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_speicher_pumpe',
            type    => 'GAUGE',
        },
        archive     => { 
            rows     => 2102400,
            cpoints  => 5,
            cfunc    => 'LAST',
        },
        archive     => { 
            rows     => 525600,
            cpoints  => 1,
            cfunc    => 'AVERAGE',
        },
        archive     => { 
            rows     => 105120,
            cpoints  => 5,
            cfunc    => 'MAX',
        },
        archive     => { 
            rows     => 105120,
            cpoints  => 5,
            cfunc    => 'MIN',
        }
);
$rc = $heizkreis_rrdh->create(
    start       => $start_time - 600,
    step        => 60,
        data_source => { 
            name    => 'T_aussen',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'T_soll_HK1',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'T_ist_HK1',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'T_steuer_FB',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'C_betrieb_gesamt',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'C_betrieb_heizung',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'C_brenner_gesamt',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'C_brenner_heizung',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_betriebs_art',
            type    => 'GAUGE',
        },
        archive     => { 
            rows     => 2102400,
            cpoints  => 5,
            cfunc    => 'LAST',
        },
        archive     => { 
            rows     => 525600,
            cpoints  => 1,
            cfunc    => 'AVERAGE',
        },
        archive     => { 
            rows     => 105120,
            cpoints  => 5,
            cfunc    => 'MAX',
        },
        archive     => { 
            rows     => 105120,
            cpoints  => 5,
            cfunc    => 'MIN',
        }
);
$rc = $warmwasser_rrdh->create(
    start       => $start_time - 600,
    step        => 60,
        data_source => { 
            name    => 'T_soll',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'T_ist',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'T_speicher',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'C_betriebs_zeit',
            type    => 'GAUGE',
        },
        archive     => { 
            rows     => 2102400,
            cpoints  => 5,
            cfunc    => 'LAST',
        },
        archive     => { 
            rows     => 525600,
            cpoints  => 1,
            cfunc    => 'AVERAGE',
        },
        archive     => { 
            rows     => 105120,
            cpoints  => 5,
            cfunc    => 'MAX',
        },
        archive     => { 
            rows     => 105120,
            cpoints  => 5,
            cfunc    => 'MIN',
        }
);
$rc = $solar_rrdh->create(
    start       => $start_time - 600,
    step        => 60,
        data_source => { 
            name    => 'T_kollektor',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'T_speicher_unten',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_ertrag_stunde',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_ertrag_2',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_solar_pumpe',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'C_laufzeit',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_ertrag_tag_calc',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'V_ertrag_sum_calc',
            type    => 'GAUGE',
        },
        archive     => { 
            rows     => 2102400,
            cpoints  => 5,
            cfunc    => 'LAST',
        },
        archive     => { 
            rows     => 525600,
            cpoints  => 1,
            cfunc    => 'AVERAGE',
        },
        archive     => { 
            rows     => 105120,
            cpoints  => 5,
            cfunc    => 'MAX',
        },
        archive     => { 
            rows     => 105120,
            cpoints  => 5,
            cfunc    => 'MIN',
        }
);
$rc = $sysdatetime_rrdh->create(
    start       => $start_time - 600,
    step        => 60,
        data_source => { 
            name    => 'Date',
            type    => 'GAUGE',
        },
        data_source => { 
            name    => 'Time',
            type    => 'GAUGE',
        },
        archive     => { 
            rows     => 2102400,
            cpoints  => 5,
            cfunc    => 'LAST',
        },
        archive     => { 
            rows     => 525600,
            cpoints  => 1,
            cfunc    => 'AVERAGE',
        },
        archive     => { 
            rows     => 105120,
            cpoints  => 5,
            cfunc    => 'MAX',
        },
        archive     => { 
            rows     => 105120,
            cpoints  => 5,
            cfunc    => 'MIN',
        }
);
